#include <iostream>
#include <iomanip>

//  Calcul de y0(x) = m  <==>  m^m = x
//  xmin = (1/e)^(1/e) = 0.69220062755534636 < x < 1
//  ymax = y0(xmin) = 1/e = 0.36787944117144232
//  ymin = y0(1) = 0.0
//  amin doit tre trs petit et bmax = 2.0/e = 0.735758882342885
double fy0(double x) {
    if(x < 0.69220062755534636 || x >= 1.0) return 0.0;
    double a = 0.00000000000000000000000001;
    if(pow(a,a) < x) return 0.0;
    double b = 0.735758882342885;
    double m, mm, n=0.0;
    do {
        m = (a+b)/2.0;
        if(m == n) break;
        mm = pow(m,m);
        if(mm > x) a = m; 
        if(mm < x) b = m; 
        n = m;
    }while((abs(mm-x) > 0.0) && (b-a > 0.0));
    return m;
}

int main(int argc, char ** argv) {
    while(true) {
        double x;
        std::cout << std::endl << "Entrez x : ";
        std::cin >> x;
        if(x <= 0.0) break;
        std::cout << "x = " << std::setprecision(15) << x << "   y0(x) = " << fy0(x) << std::endl;
    }
    return 0;
}